﻿--[[
	This file is part of PlayerZone AddOn for WoW 3.3.5a
	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	
	Copyright © 2017 Yulemath
]]

local PlayerZone = LibStub("AceAddon-3.0"):GetAddon("PlayerZone")
local L = LibStub("AceLocale-3.0"):GetLocale("PlayerZone")

-- Loading BlizOptions
local options = nil

local function OptionsTbl()
local db = PlayerZone.db.profile
if not options then
options = {
	name = "PlayerZone",
    type = "group",
    args = {
		general = {
			name = "General Settings",
            type = "group",
			order = 1,
            args = {
				intro = {
					order = 1,
					type = "description",
					name = L["PlayerZone vous permet d'afficher le nom des régions ainsi que leur niveau moyen. Vous pouvez également régler l'affichage des instances sur la WorldMap."],
				},
				space1 = { order = 2, type = "description", name = ""},
				space2 = { order = 3, type = "description", name = ""},
				desc1 = {
					order = 4,
					type = "description",
					name = L["|cffffff00Cet AddOn est désormais compatible avec Mapster. Carbonite, en revanche, n'est pas pris en charge car il intègre déjà des fonctionalités similaires à PlayerZone et même bien plus.|r"],
				},
				space3 = { order = 5, type = "description", name = ""},
				space4 = { order = 6, type = "description", name = ""},
				desc2 = {
					order = 7,
					type = "description",
					name = L["|cffffff00De nouvelles fonctionalités devraient venir dans le futur, n'hésitez pas à jeter un œil sur le site Curse ou via votre application Twitch.|r"],
				},
				space5 = { order = 8, type = "description", name = ""},
				space6 = { order = 9, type = "description", name = ""},
				space7 = { order = 10, type = "description", name = ""},
				space8 = { order = 11, type = "description", name = ""},
				metadata1 = {
					order = 12,
					type = "description",
					name = L["Auteur : "]..PlayerZone_AUTHOR,
				},
				metadata2 = {
					order = 13,
					type = "description",
					name = "Version : "..PlayerZone_VERSION,
				},
				metadata3 = {
					order = 14,
					type = "description",
					name = "Date : "..PlayerZone_XDATE,
				},
				metadata4 = {
					order = 15,
					type = "description",
					name = "Site : "..PlayerZone_XWEBSITE,
				},
			},
        },
		options = {
			name = "Options",
			type = "group",
			order = 2,
			args = {
				desc1 = {
					order = 0,
					type = "description",
					name = L["|cffaaaaffGénéralités.|r"],
				},
				space1 = { order = 1, type = "description", name = ""},
				space2 = { order = 2, type = "description", name = ""},
				mainS = {
					order = 3,
					type = "toggle",
					name = L["Fenêtre Principale"],
					desc = L["Bascule l'affichage de la fenêtre principale"],
					set = function() db.mainS = not db.mainS end,
					get = function() return db.mainS end,						
				},
				wmS = {
					order = 4,
					type = "toggle",
					name = L["Instances WorldMap"],
					desc = L["Bascule l'affichage des instances et le niveau de région sur la WorldMap"],
					set = function() db.wmS = not db.wmS end,
					get = function() return db.wmS end,					
				},
				coords = {
					order = 5,
					type = "toggle",
					name = L["Coordonnées WorldMap"],
					desc = L["Bascule l'affichage des coordonnées du joueur sur la WorldMap"],
					set = function() db.coords = not db.coords end,
					get = function() return db.coords end,					
				},
				lock = {
					order = 6,
					type = "toggle",
					name = L["Vérouillage"],
					desc = L["Bascule le vérouillage de la fenêtre principale"],
					set = function() db.lock = not db.lock end,
					get = function() return db.lock end,					
				},
				desc2 = {
					order = 7,
					type = "description",
					name = L["|cffaaaaffRéglage de la couleur et de la texture de la fenêtre principale.|r"],
				},
				space4 = { order = 8, type = "description", name = ""},
				space5 = { order = 9, type = "description", name = ""},
				color = {
					order = 10,
					type = "color",
					name = L["Couleur"],
					desc = L["Cliquer pour choisir la couleur"],
					get = function(info) return db.color.r, db.color.g, db.color.b, db.color.a end,
					set = function(info, r, g, b, a) 
						db.color.r = r
						db.color.g = g
						db.color.b = b
						db.color.a = a
						PlayerZone:ColorSet(r, g, b, a)
					end,
					hasAlpha = true,
				},
				texture = {
					order = 11,
					type = "select",
					style = "radio",
					name = "Texture",
					desc = L["Cliquer pour choisir la texture."],
					values = function() return db.texture.list end,
					get = function(info) return db.texture.v end,
					set = function(info, val)
						db.texture.v = val
						db.texture.selected = db.texture.list[val]
						end
				},
				space8 = { order = 15, type = "description", name = ""},
				desc3 = {
					order = 16,
					type = "description",
					name = L["|cffaaaaffAffichage du plugin de la MiniMap.|r"],
				},
				space9 = { order = 17, type = "description", name = ""},
				space10 = { order = 18, type = "description", name = ""},
				pShow = {
					order = 19,
					type = "toggle",
					name = "Plugin MiniMap",
					desc = L["Bascule l'affichage du plugin sur la minimap"],
					set = function() db.plugin = not db.plugin end,
					get = function() return db.plugin end,
				},
				space11 = { order = 20, type = "description", name = ""},
				space12 = { order = 21, type = "description", name = ""},
				desc4 = {
					order = 22,
					type = "description",
					name = L["|cffaaaaffRéglage des Fonts de la fenêtre principale.|r"],
				},
				space13 = { order = 23, type = "description", name = ""},
				space14 = { order = 24, type = "description", name = ""},
				fontSelect = {
					order = 25,
					type = "select",
					style = "radio",
					name = L["Sélection de la Font"],
					desc = L["Sélection de la Font de la fenêtre principale"],
					values = function() return db.font.list end,
					get = function() return db.font.v end,
					set = function(self, val)
						db.font.v = val
						db.font.selected = db.font.list[val]
						end
				},
				space15 = { order = 26, type = "description", name = ""},
				space16 = { order = 27, type = "description", name = ""},
				fontSize = {
					order = 28,
					type = "range",
					name = L["Taille de la Font"],
					desc = L["Règle la taille de la Font de la fenêtre principale"],
					set = function() db.font.size = this:GetValue() end,
					get = function() return db.font.size end,
					min = 10, 
					max = 24, 
					bigStep = 1,
					isPercent = false,
				},
				space17 = { order = 29, type = "description", name = ""},
				space18 = { order = 30, type = "description", name = ""},
			},
		},
	},
}
end
PlayerZone:OptionsChanged()
return options
end

local function optFunc()
	InterfaceOptionsFrame_OpenToCategory(PlayerZone.optionsFrames.Options)
	InterfaceOptionsFrame_OpenToCategory(PlayerZone.optionsFrames.PlayerZone)
	PlaySound("igCharacterInfoTab")
end

function PlayerZone:SetupOptions()

	self.optionsFrames = {}
	
	--setup options table
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("PlayerZone", OptionsTbl)

	self.optionsFrames.PlayerZone = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PlayerZone", nil, nil, "general")
	self.optionsFrames.Options = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PlayerZone", "Options", "PlayerZone", "options")
	
	LibStub("AceConsole-3.0"):RegisterChatCommand("playerzone", optFunc)
end

local function ToggleFrame(frame, data)
	if ( data ) then
		frame:Show()
	else
		frame:Hide()
	end
end

function PlayerZone:ColorSet(r, g, b, a)
	PlayerZoneFrame:SetBackdropColor(r, g, b, a)
	PlayerZoneLevelFrame:SetBackdropColor(r, g, b, a)
end

function PlayerZone:OptionsChanged()
	local db = self.db.profile
	ToggleFrame(PlayerZoneFrame, db.mainS)
	if ( db.levelF ) then ToggleFrame(PlayerZoneLevelFrame, db.mainS) end
	ToggleFrame(PlayerZoneWMIFrame, db.wmS)
	ToggleFrame(LibDBIcon10_PlayerZonePlugin, db.plugin)
	ToggleFrame(PlayerZoneCoordsFrame, db.coords)
	self:SetNewFont(db)
	self:SetTexture(db)
	self:ColorSet(db.color.r, db.color.g, db.color.b, db.color.a)
end

function PlayerZone:SetNewFont()
local db = self.db.profile
local font = "Interface\\AddOns\\PlayerZone\\Fonts\\"..db.font.selected..".ttf"
	PlayerZoneFrameText1:SetFont(font, db.font.size, "")
	if ( PlayerZoneFrameText2:IsShown() ) then PlayerZoneFrameText2:SetFont(font, db.font.size, "") end
	PlayerZoneLevelText:SetFont(font, db.font.size, "")
	self:SetFrameSize()
end

function PlayerZone:SetTexture()
local db = self.db.profile
local selected = db.texture.selected
local texture = "Interface\\AddOns\\PlayerZone\\Artworks\\"..selected..".tga"
local background = "Interface\\Tooltips\\UI-Tooltip-Background"
if ( PlayerZoneFrame:IsShown() ) then
	if ( selected == "UI-TextBackground-Backdrop" ) then
	PlayerZoneFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 6, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	elseif ( selected == "Glue-Tooltip-Border" ) then
	PlayerZoneFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 12, 
		insets = { left = 6, right = 4, top = 4, bottom = 6 }
	})
	elseif ( selected == "TextPanel-Border" ) then
	PlayerZoneFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 3, top = 3, bottom = 4 }
	})
	else
	PlayerZoneFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	end
end
if ( PlayerZoneLevelFrame:IsShown() ) then
	if ( selected == "UI-TextBackground-Backdrop" ) then
	PlayerZoneLevelFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 6, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	elseif ( selected == "Glue-Tooltip-Border" ) then
	PlayerZoneLevelFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 12, 
		insets = { left = 6, right = 4, top = 4, bottom = 6 }
	})
	elseif ( selected == "TextPanel-Border" ) then
	PlayerZoneLevelFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 3, top = 3, bottom = 4 }
	})
	else
	PlayerZoneLevelFrame:SetBackdrop( { 
		bgFile = background, 
		edgeFile = texture, tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	end
end
end